# -*- coding: utf-8 -*-
"""
Инициализация графического интерфейса пользователя:

(c)2012,2013 ЗАО "РИПАС" и Демин Федор,
www.ripas.ru dff@ripas.ru
"""
import gui, RoadCentre
from PythonQt import QtCore

QtCore.qDebug((u'Старт инициализации графической подсистемы программы ' + QtCore.QCoreApplication.instance().applicationName).encode('utf8'))

gui.pythonConsole=getattr(RoadCentre,'pythonConsole',None)

if not gui.setupUi('MainWindow.ui'):
    raise Exception(u'Ошибка инициализации графической подсистемы: Не удалось создать главное окно приложения')

if not gui.osmView.inherits('OsmView'):
    raise Exception(u'Ошибка инициализации графической подсистемы: Не удалось создать окно карты')

mainWindow=gui.mainWindow
gui.osmView.verticalScrollBarPolicy=QtCore.Qt.ScrollBarAlwaysOff
gui.osmView.horizontalScrollBarPolicy=QtCore.Qt.ScrollBarAlwaysOff

import menu
m=menu.Menu(RoadCentre.kernel)
m.setWidgetContextMenu(gui.osmView)
if gui.osmView2: m.setWidgetContextMenu(gui.osmView2)
if gui.imageView: m.setWidgetContextMenu(gui.imageView)
m.setWidgetContextMenu(gui.treeView)
m.setWidgetContextMenu(gui.tableView)
m.setWidgetContextMenu(gui.listView)

from recentFiles import initRecentList
initRecentList()

defaultLoaded=gui.mainWindow.findChild('QAction','defaultLoaded')
if defaultLoaded:
    if getattr(RoadCentre,'project_supported',None):
        defaultLoaded.connect('toggled(bool)',gui.changeDefaultLoaded)
    else:
        defaultLoaded.setEnabled(False)

menuService=gui.mainWindow.findChild('QMenu','menuService')
if menuService is not None:
    try:
        from settings import openUserSettingsInTextEditor,openSystemSettingsInTextEditor,openProjectSettingsInTextEditor
        menuService.addAction(u'Открыть системный файл конфигурации').connect('triggered()',openSystemSettingsInTextEditor)
        menuService.addAction(u'Открыть пользовательский файл конфигурации').connect('triggered()',openUserSettingsInTextEditor)
        menuService.addAction(u'Открыть файл конфигурации проекта').connect('triggered()',openProjectSettingsInTextEditor)
        if not RoadCentre.kernel.wallet.isUsingSystemWallet():
            def open_wallet():
                from gui import mainWindow
                RoadCentre.kernel.wallet.open(mainWindow)
            menuService.addAction(u'Открыть локальное хранилище паролей').connect('triggered()',open_wallet)
        try:
            from ssh import configureDefaults
            menuService.addAction(u'Настроить умолчания для SSH').connect('triggered()',configureDefaults)
        except: pass
    except: raise
    del menuService
RoadCentre.gui = gui
QtCore.qDebug('Инициализация графической подсистемы выполнена')
