# -*- coding: utf-8 -*-
"""
Инициализация обработчиков различных событий

(c)2012-2013 ЗАО "РИПАС" и Демин Федор,
www.ripas.ru dff@ripas.ru
"""

import actions,textsearch
from layers import editLayersOrder
from RoadCentre import kernel,plugins
try:
    from RoadCentre import project_supported
except:
    project_supported = False
from settings import userSettings
import gui
from PythonQt import Qt,QtGui
import sys

kernel.selectionModel.connect('selectionChanged(const QItemSelection&, const QItemSelection&)', actions.selectionChanged)
action=gui.mainWindow.findChild(Qt.QAction,'actionConnect')
if action:
    action.connect('triggered(bool)', actions.actionConnect)
    action.statusTip = u'Установить/разорвать соединение с сервером АСУДД'

actions.openFileDialog.nameFilter = dict()
actions.saveFileDialog.nameFilter = dict()

action=gui.mainWindow.findChild(Qt.QAction,'actionOpen')
if action:
    if project_supported:
        action.connect('triggered()', actions.openFileDialog)
        action.statusTip = u'Открыть новый проект'
    else:
        action.setEnabled(False)

action=gui.mainWindow.findChild(Qt.QAction,'actionClose')
if action:
    if project_supported:
        action.connect('triggered()', actions.closeProject)
    else:
        action.setEnabled(False)

action = gui.mainWindow.findChild(Qt.QAction, 'actionSave')
if action:
    if project_supported:
        action.connect('triggered()', actions.saveFile)
        action.statusTip = u'Сохранить текущий проект'
    else:
        action.setEnabled(False)

action = gui.mainWindow.findChild(Qt.QAction, 'actionSaveAs')
if action:
    if project_supported:
        action.connect('triggered()', actions.saveFileDialog)
        action.statusTip = u'Сохранить текущий проект в другом формате и(или) под другим именем'
    else:
        action.setEnabled(False)

gr=Qt.QActionGroup(None)
action=gui.mainWindow.findChild(Qt.QAction,'actionMoveMode')
if action:
    action.setData(QtGui.QGraphicsView.ScrollHandDrag)
    gr.addAction(action)

action=gui.mainWindow.findChild(Qt.QAction,'actionSelectionMode')
if action:
    action.setData(QtGui.QGraphicsView.RubberBandDrag)
    gr.addAction(action)

gr.connect('triggered(QAction*)', actions.actionMode)
actions.actionMode.gr = gr

action = gui.mainWindow.findChild(Qt.QAction, 'actionTileDownload')
if action and hasattr(gui.osmView,'enableTileDownload'):
    action.connect('triggered(bool)', actions.tileDownload)
    action.checked=userSettings.value('enableTileDownload',0)=='1'
    action.statusTip = u'Включить/выключить загрузку отсутствующих тайлов'
    if gui.osmView.enableTileDownload!=action.checked:
        gui.osmView.enableTileDownload=action.checked

action = gui.mainWindow.findChild(Qt.QAction, 'actionFindController')
has_spectr = hasattr(plugins,'SpectrPlugin')
if has_spectr and action:
    action.connect('triggered()', actions.findController)
    action.statusTip = action.toolTip
if not has_spectr:
    action.delete()
action = gui.mainWindow.findChild(Qt.QAction, 'actionFindControllerByDescription')
if has_spectr and action:
    action.connect('triggered()', textsearch.runSearch)
    action.statusTip = action.toolTip
if not has_spectr:
    action.delete()

action = gui.mainWindow.findChild('QAction','actionFull_screen')
if action:
    action.connect('triggered(bool)', actions.fullScreen)

action = gui.mainWindow.findChild('QAction','actionAbout_Qt')
if action:
    action.connect('triggered()', actions.AboutQt)

action = gui.mainWindow.findChild('QAction','actionAbout_plugins')
if action:
    action.connect('triggered()', actions.AboutPlugins)

action = gui.mainWindow.findChild('QAction','actionAbout')
if action:
    action.connect('triggered()', actions.About)

action = gui.mainWindow.findChild('QAction','externalModules')
if not sys.platform.startswith("linux"):
    if action:
        action.connect('triggered()', actions.AboutExternalModules)
else:
    action.deleteLater()

action = gui.mainWindow.findChild('QAction','actionLayers_order')
if action:
    action.connect('triggered()', editLayersOrder)

menu = gui.mainWindow.findChild('QMenu','menuStyle')
if menu:
    gr=Qt.QActionGroup(None)
    currentStyle = QtGui.QApplication.style().className()
    for key in QtGui.QStyleFactory.keys():
        action = menu.addAction(key)
        gr.addAction(action)
        action.checkable = True
        if currentStyle == QtGui.QStyleFactory.create(key).className(): action.checked = True
    gr.connect('triggered(QAction*)', actions.setStyle)
    actions.setStyle.gr = gr

gui.msgOk(u'Инициализации обработчиков событий выполнена')
