# -*- coding: utf-8 -*-
"""

(c)2012-2013 ЗАО "РИПАС"
www.ripas.ru
"""
from PythonQt import QtCore, QtGui
from gui import mainWindow
from settings import userSettings
import RoadCentre
import os

MaxRecentFiles = 5
recentFileActs = list(range(MaxRecentFiles))


def initRecentList():
    if not getattr(RoadCentre,'project_supported',None):
        return
    fileMenu = mainWindow.findChild('QMenu', 'menuFile')
    if not fileMenu:
        return
    gr = QtGui.QActionGroup(fileMenu)
    for act in recentFileActs:
        recentFileActs[act] = QtGui.QAction(fileMenu)
        recentFileActs[act].visible = False
        gr.addAction(recentFileActs[act])

    separatorAct = fileMenu.insertSeparator(mainWindow.findChild('QAction', 'actionExit'))
    for act in gr.actions():
        fileMenu.insertAction(separatorAct, act)
    gr.connect('triggered(QAction*)', openRecentFile)
    readRecentList()

    del gr, separatorAct, fileMenu


def readRecentList():
    size = userSettings.beginReadArray("RecentFileList")
    ri = 0
    readed_files = []
    for c in range(size):
        userSettings.setArrayIndex(c)
        fileName = userSettings.value("file","").replace('&','')
        if fileName not in readed_files and os.path.isfile(fileName):
            readed_files.append(fileName)
            recentFileActs[ri].setText(fileName)
            recentFileActs[ri].visible = True
            ri += 1
        if ri >= MaxRecentFiles:
            break
    userSettings.endArray()


def updateRecentList(file_name):
    emptyAct = None
    for act in recentFileActs:
        if act.text.replace('&','') == file_name:
            return
        if not emptyAct and not act.visible:
            emptyAct = act
    if not emptyAct:
        rng = list(range(MaxRecentFiles))
        rng.reverse()
        del rng[-1]
        for i in rng:
            recentFileActs[i].text = recentFileActs[i - 1].text.replace('&','')
        emptyAct = recentFileActs[0]
    emptyAct.text = file_name
    emptyAct.visible = True
    saveRecentList()


def openRecentFile(act):
    fileName = act.text.replace('&','')
    if os.path.exists(fileName):
        from actions import openFile
        openFile(fileName)


def saveRecentList():
    recentFiles = []
    for act in recentFileActs:
        if act.visible:
            recentFiles.append(act.text.replace('&',''))
    if len(recentFiles) > 0:
        userSettings.beginWriteArray('RecentFileList')
        i = 0
        for item in recentFiles:
            userSettings.setArrayIndex(i)
            userSettings.setValue("file", item)
            i = i + 1
        userSettings.endArray()
        userSettings.sync()
